<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/3_Game/Client/Notifications/NotificationSystem.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.18.155069</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d5/d74/_notification_system_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">NotificationSystem.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d5/d74/_notification_system_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a3676598f5cfb667a8b9dffe03b3c9baf">    1</a></span><span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a3676598f5cfb667a8b9dffe03b3c9baf">NOTIFICATION_FADE_TIME</a> = 3.0;</div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">    3</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span>{</div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9ae11bf5dfdc372c73f21bceee4320112b">    5</a></span>    <a class="code hl_enumvalue" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9ae11bf5dfdc372c73f21bceee4320112b">FRIEND_CONNECTED</a>,</div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a9c6c7e65cecaac62ee4b76a0f1d3ebc2">    6</a></span>    <a class="code hl_enumvalue" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a9c6c7e65cecaac62ee4b76a0f1d3ebc2">INVITE_FAIL_SAME_SERVER</a>,</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9ae7a052f37527cc17f123dac1241dddb5">    7</a></span>    <a class="code hl_enumvalue" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9ae7a052f37527cc17f123dac1241dddb5">JOIN_FAIL_GET_SESSION</a>,</div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a0de158d87daa355528084aebdb9da385">    8</a></span>    <a class="code hl_enumvalue" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a0de158d87daa355528084aebdb9da385">CONNECT_FAIL_GENERIC</a>,</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>    <span class="comment">//Please add types before this item</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>    <a class="code hl_enumvalue" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a2820e27f123f5800d15f67cc2d461e16">NOTIFICATIONS_END</a></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a2820e27f123f5800d15f67cc2d461e16">   11</a></span>}</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="keyword">class </span><a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">   15</a></span>    ref <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a>    <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">m_StaticData</a>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a70f2faf0498cb4b06e14b207410a6c31">   17</a></span>    <span class="keywordtype">float</span>                   <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a70f2faf0498cb4b06e14b207410a6c31">m_NotificationTime</a>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a71b3ed40bb4478278fa4e8833fcbe924">   18</a></span>    <span class="keywordtype">string</span>                  <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a71b3ed40bb4478278fa4e8833fcbe924">m_DetailText</a>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>    </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">   20</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a>( <span class="keywordtype">float</span> time, <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a> data, <span class="keywordtype">string</span> detail_text )</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    {</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a70f2faf0498cb4b06e14b207410a6c31">m_NotificationTime</a>  = time + <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a3676598f5cfb667a8b9dffe03b3c9baf">NOTIFICATION_FADE_TIME</a>;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>        <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">m_StaticData</a>        = data;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        <span class="keywordflow">if</span> ( detail_text != <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>            <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a71b3ed40bb4478278fa4e8833fcbe924">m_DetailText</a>    = detail_text;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>            <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a71b3ed40bb4478278fa4e8833fcbe924">m_DetailText</a>    = <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">m_StaticData</a>.m_DescriptionText;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>    }</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    </div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a5badf8ecd567b95a4733cc214e8ed418">   30</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a5badf8ecd567b95a4733cc214e8ed418">SetTime</a>( <span class="keywordtype">float</span> time )</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>    {</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>        <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a70f2faf0498cb4b06e14b207410a6c31">m_NotificationTime</a> = time;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    }</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a8a5888c845f10608a75d9bfd5009089e">   35</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a8a5888c845f10608a75d9bfd5009089e">GetTime</a>()</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    {</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a70f2faf0498cb4b06e14b207410a6c31">m_NotificationTime</a>;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    }</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>    </div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a79916e01de700c478fb060eac35570b7">   40</a></span>    <span class="keywordtype">string</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a79916e01de700c478fb060eac35570b7">GetIcon</a>()</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>    {</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">m_StaticData</a>.m_Icon;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    }</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#a7d30f509b95a5dd1dd58b174f73c2929">   45</a></span>    <span class="keywordtype">string</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a7d30f509b95a5dd1dd58b174f73c2929">GetTitleText</a>()</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>    {</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">m_StaticData</a>.m_TitleText;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    }</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="../../d5/d74/_notification_system_8c.html#ac63ca1eeab502ce158167b41ee5bf3d3">   50</a></span>    <span class="keywordtype">string</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#ac63ca1eeab502ce158167b41ee5bf3d3">GetDetailText</a>()</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    {</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d5/d74/_notification_system_8c.html#a71b3ed40bb4478278fa4e8833fcbe924">m_DetailText</a>;</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    }</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>}</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html">   56</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d8/d5d/class_notification_system.html">NotificationSystem</a></div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>{</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#ab5a00ea7e797bc6798e507516af874d6">   58</a></span>    <span class="keyword">protected</span> <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">string</span>                               <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ab5a00ea7e797bc6798e507516af874d6">JSON_FILE_PATH</a> = <span class="stringliteral">&quot;Scripts/Data/notifications.json&quot;</span>;                 </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#ac129cd2c54317d2f5263c3d5c519e17c">   59</a></span>    <span class="keyword">protected</span> <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span>                                  <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac129cd2c54317d2f5263c3d5c519e17c">MAX_NOTIFICATIONS</a> = 5;                  </div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">   61</a></span>    <span class="keyword">protected</span> <span class="keyword">static</span> ref <a class="code hl_class" href="../../d8/d5d/class_notification_system.html">NotificationSystem</a>                     <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>                </div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">   63</a></span>    <span class="keyword">protected</span> ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref NotificationRuntimeData&gt;</a>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">   64</a></span>    <span class="keyword">protected</span> ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref NotificationRuntimeData&gt;</a>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">   65</a></span>    <span class="keyword">protected</span> ref <a class="code hl_enumeration" href="../../d6/d7f/_controls_xbox_new_8c.html#a9ec9dda576db2a36c42c1c3af155d07c">map&lt;NotificationType, ref NotificationData&gt;</a>   <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>;</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    </div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">   67</a></span>    <span class="keyword">protected</span> ref <a class="code hl_class" href="../../d4/d2d/class_script_invoker.html">ScriptInvoker</a>                                 <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">m_OnNotificationAdded</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../d4/d2d/class_script_invoker.html">ScriptInvoker</a>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#acb32923e01fc67d980439e7da2407c6a">   68</a></span>    <span class="keyword">protected</span> ref <a class="code hl_class" href="../../d4/d2d/class_script_invoker.html">ScriptInvoker</a>                                 <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#acb32923e01fc67d980439e7da2407c6a">m_OnNotificationRemoved</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../d4/d2d/class_script_invoker.html">ScriptInvoker</a>;</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    </div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#adf618ab8cfabc3d79cbc3f35c26621fa">   70</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#adf618ab8cfabc3d79cbc3f35c26621fa">NotificationSystem</a>()</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    {</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a> = <span class="keyword">this</span>;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span><span class="preprocessor">        #ifndef WORKBENCH</span></div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref NotificationRuntimeData&gt;</a>;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref NotificationRuntimeData&gt;</a>;</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a07f1bafadece3a8c6d114a987924c408">LoadNotificationData</a>();</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span><span class="preprocessor">        #endif</span></div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>    }</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>    </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a3e6bc3f389d05081eff4c46a85e4c0e7">   89</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a3e6bc3f389d05081eff4c46a85e4c0e7">SendNotificationToPlayerExtended</a>( Man player, <span class="keywordtype">float</span> show_time, <span class="keywordtype">string</span> title_text, <span class="keywordtype">string</span> detail_text = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">string</span> icon = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    {</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <span class="keywordflow">if</span> ( player )</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        {</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>            <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#af38241f43138ced69a912cbc0cf36b28">SendNotificationToPlayerIdentityExtended</a>( player.GetIdentity(), show_time, title_text, detail_text, icon );</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        }</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>    }</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>    </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#af38241f43138ced69a912cbc0cf36b28">  105</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#af38241f43138ced69a912cbc0cf36b28">SendNotificationToPlayerIdentityExtended</a>( <a class="code hl_class" href="../../df/d11/class_player_identity.html">PlayerIdentity</a> player, <span class="keywordtype">float</span> show_time, <span class="keywordtype">string</span> title_text, <span class="keywordtype">string</span> detail_text = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">string</span> icon = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>    {</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <a class="code hl_class" href="../../d5/d8a/class_script_r_p_c.html">ScriptRPC</a> rpc = <span class="keyword">new</span> <a class="code hl_class" href="../../d5/d8a/class_script_r_p_c.html">ScriptRPC</a>();</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        </div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(show_time);</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(title_text);</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(detail_text);</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(icon);</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        rpc.<a class="code hl_function" href="../../d5/d8a/class_script_r_p_c.html#a96f5185fa93cf7f008fba76a0e7729b9">Send</a>(null, <a class="code hl_enumeration" href="../../d0/d66/_e_r_p_cs_8c.html#a6ce2d98a3b8fbdba5b450abf2d6eab37">ERPCs</a>.RPC_SEND_NOTIFICATION_EXTENDED, <span class="keyword">true</span>, player);</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    }</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    </div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a1c7d6fb167abfdbdd4eb31f8715ebdf4">  124</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a1c7d6fb167abfdbdd4eb31f8715ebdf4">SendNotificationToPlayer</a>( Man player, <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a> type, <span class="keywordtype">float</span> show_time, <span class="keywordtype">string</span> detail_text = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>    {</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>        <span class="keywordflow">if</span> ( player )</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        {</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>            <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#ac63f365098df3610099b710a80b939f9">SendNotificationToPlayerIdentity</a>( player.GetIdentity(), type, show_time, detail_text );</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>        }</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>    }</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>    </div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#ac63f365098df3610099b710a80b939f9">  139</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#ac63f365098df3610099b710a80b939f9">SendNotificationToPlayerIdentity</a>( <a class="code hl_class" href="../../df/d11/class_player_identity.html">PlayerIdentity</a> player, <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a> type, <span class="keywordtype">float</span> show_time, <span class="keywordtype">string</span> detail_text = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>    {</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        <a class="code hl_class" href="../../d5/d8a/class_script_r_p_c.html">ScriptRPC</a> rpc = <span class="keyword">new</span> <a class="code hl_class" href="../../d5/d8a/class_script_r_p_c.html">ScriptRPC</a>();</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(type);</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(show_time);</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        rpc.<a class="code hl_function" href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Write</a>(detail_text);</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        rpc.<a class="code hl_function" href="../../d5/d8a/class_script_r_p_c.html#a96f5185fa93cf7f008fba76a0e7729b9">Send</a>(null, <a class="code hl_enumeration" href="../../d0/d66/_e_r_p_cs_8c.html#a6ce2d98a3b8fbdba5b450abf2d6eab37">ERPCs</a>.RPC_SEND_NOTIFICATION, <span class="keyword">true</span>, player);</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>    }</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>    </div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#ae7e705691ea84eaf201e629d1643d7c4">  156</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#ae7e705691ea84eaf201e629d1643d7c4">AddNotification</a>( <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a> type, <span class="keywordtype">float</span> show_time, <span class="keywordtype">string</span> detail_text = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>    {</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        <span class="keywordflow">if</span> ( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>.Count() &lt; <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac129cd2c54317d2f5263c3d5c519e17c">MAX_NOTIFICATIONS</a> )</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        {</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>            <span class="keywordtype">float</span> time = <a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().<a class="code hl_function" href="../../d2/de6/class_c_game.html#a1ca75f36e34dd2c154e0c4cbb6b767bd">GetTickTime</a>() + show_time;</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>            <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data = <span class="keyword">new</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a>(time, <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_function" href="../../d8/d5d/class_notification_system.html#aa3167112d04099cca93084c8331ed90a">GetNotificationData</a>( type ), detail_text);</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>            </div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>.Insert( data );</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">m_OnNotificationAdded</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a92afb05a0027c1949c5364a8e035e1c9">Invoke</a>( data );</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        }</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>        {</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>            <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data_def = <span class="keyword">new</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a>(show_time, <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_function" href="../../d8/d5d/class_notification_system.html#aa3167112d04099cca93084c8331ed90a">GetNotificationData</a>( type ), detail_text);</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Insert( data_def );</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        }</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>    }</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>    </div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a8801348912f09d638199bf0596cbe7d8">  180</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a8801348912f09d638199bf0596cbe7d8">AddNotificationExtended</a>( <span class="keywordtype">float</span> show_time, <span class="keywordtype">string</span> title_text, <span class="keywordtype">string</span> detail_text = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">string</span> icon = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>    {</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        <span class="keywordflow">if</span>( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>.Count() &lt; <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac129cd2c54317d2f5263c3d5c519e17c">MAX_NOTIFICATIONS</a> )</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>        {</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>            <span class="keywordtype">float</span> time = <a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().<a class="code hl_function" href="../../d2/de6/class_c_game.html#a1ca75f36e34dd2c154e0c4cbb6b767bd">GetTickTime</a>() + show_time;</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>            </div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>            <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a> temp_data = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a>( icon, title_text );</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>            <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data = <span class="keyword">new</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a>(time, temp_data, detail_text);</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>            </div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>.Insert( data );</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">m_OnNotificationAdded</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a92afb05a0027c1949c5364a8e035e1c9">Invoke</a>( data );</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        }</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        {</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>            <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a> temp_data_def = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a>( icon, title_text );</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>            <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data_def = <span class="keyword">new</span> <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a>(show_time, temp_data_def, detail_text);</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>            <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Insert( data_def );</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>        }</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>    }</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>    </div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#af5398c705e25a566eed46024a86fdb71">  200</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#af5398c705e25a566eed46024a86fdb71">Update</a>(<span class="keywordtype">float</span> timeslice)</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>    {</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>        <span class="keywordflow">if</span>( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a> )</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>        {</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>            <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;NotificationRuntimeData&gt;</a> to_remove = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;NotificationRuntimeData&gt;</a>;</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>            <span class="keywordflow">foreach</span>( <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data : <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a> )</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>            {</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>                <span class="keywordflow">if</span>( data.GetTime() &lt; <a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().GetTickTime() )</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>                {</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>                    to_remove.Insert( data );</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>                } </div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>            }</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>            </div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>            <span class="keywordflow">foreach</span>( <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data2 : to_remove )</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>            {</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>                <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>.RemoveItem( data2 );</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>                <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#acb32923e01fc67d980439e7da2407c6a">m_OnNotificationRemoved</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a92afb05a0027c1949c5364a8e035e1c9">Invoke</a>( data2 );</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>                </div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>                <span class="keywordflow">if</span>( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Count() &gt; 0 )</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>                {</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>                    <a class="code hl_function" href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a> data_def = <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Get( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Count() - 1 );</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>                    <span class="keywordtype">float</span> time = <a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().<a class="code hl_function" href="../../d2/de6/class_c_game.html#a1ca75f36e34dd2c154e0c4cbb6b767bd">GetTickTime</a>() + data_def.GetTime();</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>                    data_def.SetTime( time );</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>                    <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">m_TimeArray</a>.Insert( data_def );</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>                    <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">m_OnNotificationAdded</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a92afb05a0027c1949c5364a8e035e1c9">Invoke</a>( data_def );</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>                    <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Remove( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">m_DeferredArray</a>.Count() - 1 );</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>                }</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>            }</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>        }</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    }</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>    </div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#aa3167112d04099cca93084c8331ed90a">  231</a></span>    <span class="keyword">protected</span> <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#aa3167112d04099cca93084c8331ed90a">GetNotificationData</a>( <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a> type )</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>    {</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        <span class="keywordflow">if</span>( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>.Contains(type) )</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>        {</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>            <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>.Get( type );</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        }</div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        </div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        <span class="keywordflow">return</span> null;</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>    }</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>    </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a07f1bafadece3a8c6d114a987924c408">  241</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a07f1bafadece3a8c6d114a987924c408">LoadNotificationData</a>()</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    {</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>        <a class="code hl_enumeration" href="../../d6/d7f/_controls_xbox_new_8c.html#a9ec9dda576db2a36c42c1c3af155d07c">map&lt;NotificationType, NotificationData&gt;</a> data_array;</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a> = <span class="keyword">new</span> <a class="code hl_enumeration" href="../../d6/d7f/_controls_xbox_new_8c.html#a9ec9dda576db2a36c42c1c3af155d07c">map&lt;NotificationType, ref NotificationData&gt;</a>;</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>        JsonFileLoader&lt;map&lt;NotificationType, NotificationData&gt;&gt;.JsonLoadFile( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ab5a00ea7e797bc6798e507516af874d6">JSON_FILE_PATH</a>, data_array );</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        </div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>.Copy( data_array );</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        </div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>        <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a> types = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a>;</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>        <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a> type_curr = 0;</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>        <span class="keywordflow">while</span> ( type_curr != <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a>.NOTIFICATIONS_END )</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>        {</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>            types.Insert( type_curr );</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>            type_curr++;</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>        }</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>        </div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>.Count(); i++ )</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>        {</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>            types.RemoveItem( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>.GetKey( i ) );</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>        }</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>        </div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>        <span class="keywordflow">if</span> ( types.Count() &gt; 0 )</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>        {</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>            <span class="keywordflow">foreach</span> ( <a class="code hl_enumeration" href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a> type2 : types )</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>            {</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>                <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a> data2 = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/dd4/class_notification_data.html">NotificationData</a>( <span class="stringliteral">&quot;please_add_an_icon&quot;</span>, <span class="stringliteral">&quot;please_add_a_title&quot;</span>, <span class="stringliteral">&quot;optional_description&quot;</span> );</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>                <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a>.Insert( type2, data2 );</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>            }</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>            JsonFileLoader&lt;map&lt;NotificationType, ref NotificationData&gt;&gt;.JsonSaveFile( <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ab5a00ea7e797bc6798e507516af874d6">JSON_FILE_PATH</a>, <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">m_DataArray</a> );</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>        }</div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>    }</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>    </div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a246d881e76cd578318fcad6166826043">  273</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a246d881e76cd578318fcad6166826043">BindOnAdd</a>( func fn )</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>    {</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">m_OnNotificationAdded</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#abeb2392b2e3dc0a34d0c5cafc96a288e">Insert</a>( fn );</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>    }</div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>    </div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#aebd399f19f7b9dbc9af2bdb868240121">  278</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#aebd399f19f7b9dbc9af2bdb868240121">UnbindOnAdd</a>( func fn )</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>    {</div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">m_OnNotificationAdded</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a704b1e426e4369c79a8495f63cfe5eed">Remove</a>( fn );</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>    }</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>    </div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#abb2abcf6b225ed82998c244a18207300">  283</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#abb2abcf6b225ed82998c244a18207300">BindOnRemove</a>( func fn )</div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>    {</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#acb32923e01fc67d980439e7da2407c6a">m_OnNotificationRemoved</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#abeb2392b2e3dc0a34d0c5cafc96a288e">Insert</a>( fn );</div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>    }</div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>    </div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno"><a class="line" href="../../d8/d5d/class_notification_system.html#a2ee4cb32ffe1717360ec7044bf45e77f">  288</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d5d/class_notification_system.html#a2ee4cb32ffe1717360ec7044bf45e77f">UnbindOnRemove</a>( func fn )</div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>    {</div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>        <a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">m_Instance</a>.<a class="code hl_variable" href="../../d8/d5d/class_notification_system.html#acb32923e01fc67d980439e7da2407c6a">m_OnNotificationRemoved</a>.<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a704b1e426e4369c79a8495f63cfe5eed">Remove</a>( fn );</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>    }</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>}</div>
<div class="ttc" id="a_controls_xbox_new_8c_html_a9ec9dda576db2a36c42c1c3af155d07c"><div class="ttname"><a href="../../d6/d7f/_controls_xbox_new_8c.html#a9ec9dda576db2a36c42c1c3af155d07c">map</a></div><div class="ttdeci">map</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d7f/_controls_xbox_new_8c_source.html#l00003">ControlsXboxNew.c:4</a></div></div>
<div class="ttc" id="a_e_r_p_cs_8c_html_a6ce2d98a3b8fbdba5b450abf2d6eab37"><div class="ttname"><a href="../../d0/d66/_e_r_p_cs_8c.html#a6ce2d98a3b8fbdba5b450abf2d6eab37">ERPCs</a></div><div class="ttdeci">ERPCs</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d66/_e_r_p_cs_8c_source.html#l00001">ERPCs.c:2</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a25a31a4bdc02a0d0adb743e26dd14ba9"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9">NotificationType</a></div><div class="ttdeci">NotificationType</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00003">NotificationSystem.c:4</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a25a31a4bdc02a0d0adb743e26dd14ba9a0de158d87daa355528084aebdb9da385"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a0de158d87daa355528084aebdb9da385">CONNECT_FAIL_GENERIC</a></div><div class="ttdeci">@ CONNECT_FAIL_GENERIC</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00008">NotificationSystem.c:8</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a25a31a4bdc02a0d0adb743e26dd14ba9a2820e27f123f5800d15f67cc2d461e16"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a2820e27f123f5800d15f67cc2d461e16">NOTIFICATIONS_END</a></div><div class="ttdeci">@ NOTIFICATIONS_END</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00011">NotificationSystem.c:10</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a25a31a4bdc02a0d0adb743e26dd14ba9a9c6c7e65cecaac62ee4b76a0f1d3ebc2"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9a9c6c7e65cecaac62ee4b76a0f1d3ebc2">INVITE_FAIL_SAME_SERVER</a></div><div class="ttdeci">@ INVITE_FAIL_SAME_SERVER</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00006">NotificationSystem.c:6</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a25a31a4bdc02a0d0adb743e26dd14ba9ae11bf5dfdc372c73f21bceee4320112b"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9ae11bf5dfdc372c73f21bceee4320112b">FRIEND_CONNECTED</a></div><div class="ttdeci">@ FRIEND_CONNECTED</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00005">NotificationSystem.c:5</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a25a31a4bdc02a0d0adb743e26dd14ba9ae7a052f37527cc17f123dac1241dddb5"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a25a31a4bdc02a0d0adb743e26dd14ba9ae7a052f37527cc17f123dac1241dddb5">JOIN_FAIL_GET_SESSION</a></div><div class="ttdeci">@ JOIN_FAIL_GET_SESSION</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00007">NotificationSystem.c:7</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a3676598f5cfb667a8b9dffe03b3c9baf"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a3676598f5cfb667a8b9dffe03b3c9baf">NOTIFICATION_FADE_TIME</a></div><div class="ttdeci">static const float NOTIFICATION_FADE_TIME</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00001">NotificationSystem.c:1</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a3a6ae2002a635ead1502f028ad39c2b5"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a3a6ae2002a635ead1502f028ad39c2b5">NotificationRuntimeData</a></div><div class="ttdeci">void NotificationRuntimeData(float time, NotificationData data, string detail_text)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00020">NotificationSystem.c:20</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a5badf8ecd567b95a4733cc214e8ed418"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a5badf8ecd567b95a4733cc214e8ed418">SetTime</a></div><div class="ttdeci">void SetTime(float time)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00030">NotificationSystem.c:30</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a70f2faf0498cb4b06e14b207410a6c31"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a70f2faf0498cb4b06e14b207410a6c31">m_NotificationTime</a></div><div class="ttdeci">float m_NotificationTime</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00017">NotificationSystem.c:17</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a71b3ed40bb4478278fa4e8833fcbe924"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a71b3ed40bb4478278fa4e8833fcbe924">m_DetailText</a></div><div class="ttdeci">string m_DetailText</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00018">NotificationSystem.c:18</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a79916e01de700c478fb060eac35570b7"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a79916e01de700c478fb060eac35570b7">GetIcon</a></div><div class="ttdeci">string GetIcon()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00040">NotificationSystem.c:40</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a7d30f509b95a5dd1dd58b174f73c2929"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a7d30f509b95a5dd1dd58b174f73c2929">GetTitleText</a></div><div class="ttdeci">string GetTitleText()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00045">NotificationSystem.c:45</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_a8a5888c845f10608a75d9bfd5009089e"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#a8a5888c845f10608a75d9bfd5009089e">GetTime</a></div><div class="ttdeci">float GetTime()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00035">NotificationSystem.c:35</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_ac63ca1eeab502ce158167b41ee5bf3d3"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#ac63ca1eeab502ce158167b41ee5bf3d3">GetDetailText</a></div><div class="ttdeci">string GetDetailText()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00050">NotificationSystem.c:50</a></div></div>
<div class="ttc" id="a_notification_system_8c_html_af00a7f1b9e8c40ccc370e93e6f45c16c"><div class="ttname"><a href="../../d5/d74/_notification_system_8c.html#af00a7f1b9e8c40ccc370e93e6f45c16c">m_StaticData</a></div><div class="ttdeci">enum NotificationType m_StaticData</div></div>
<div class="ttc" id="aclass_c_game_html_a1ca75f36e34dd2c154e0c4cbb6b767bd"><div class="ttname"><a href="../../d2/de6/class_c_game.html#a1ca75f36e34dd2c154e0c4cbb6b767bd">CGame::GetTickTime</a></div><div class="ttdeci">proto native float GetTickTime()</div><div class="ttdoc">Returns current time from start of the game.</div></div>
<div class="ttc" id="aclass_notification_data_html"><div class="ttname"><a href="../../d6/dd4/class_notification_data.html">NotificationData</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d1/d30/_notification_data_8c_source.html#l00001">NotificationData.c:2</a></div></div>
<div class="ttc" id="aclass_notification_system_html"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html">NotificationSystem</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00056">NotificationSystem.c:57</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a07f1bafadece3a8c6d114a987924c408"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a07f1bafadece3a8c6d114a987924c408">NotificationSystem::LoadNotificationData</a></div><div class="ttdeci">static void LoadNotificationData()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00241">NotificationSystem.c:241</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a1c7d6fb167abfdbdd4eb31f8715ebdf4"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a1c7d6fb167abfdbdd4eb31f8715ebdf4">NotificationSystem::SendNotificationToPlayer</a></div><div class="ttdeci">static void SendNotificationToPlayer(Man player, NotificationType type, float show_time, string detail_text=&quot;&quot;)</div><div class="ttdoc">Send notification from default types to player from server.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00124">NotificationSystem.c:124</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a246d881e76cd578318fcad6166826043"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a246d881e76cd578318fcad6166826043">NotificationSystem::BindOnAdd</a></div><div class="ttdeci">static void BindOnAdd(func fn)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00273">NotificationSystem.c:273</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a26eb1f57427f343cb943918a1f6a6c41"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a26eb1f57427f343cb943918a1f6a6c41">NotificationSystem::m_OnNotificationAdded</a></div><div class="ttdeci">protected ref ScriptInvoker m_OnNotificationAdded</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00067">NotificationSystem.c:67</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a27f580b7fec776eb9f08ecce29b444df"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a27f580b7fec776eb9f08ecce29b444df">NotificationSystem::m_DeferredArray</a></div><div class="ttdeci">protected ref array&lt; ref NotificationRuntimeData &gt; m_DeferredArray</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00064">NotificationSystem.c:64</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a2ee4cb32ffe1717360ec7044bf45e77f"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a2ee4cb32ffe1717360ec7044bf45e77f">NotificationSystem::UnbindOnRemove</a></div><div class="ttdeci">static void UnbindOnRemove(func fn)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00288">NotificationSystem.c:288</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a3e6bc3f389d05081eff4c46a85e4c0e7"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a3e6bc3f389d05081eff4c46a85e4c0e7">NotificationSystem::SendNotificationToPlayerExtended</a></div><div class="ttdeci">static void SendNotificationToPlayerExtended(Man player, float show_time, string title_text, string detail_text=&quot;&quot;, string icon=&quot;&quot;)</div><div class="ttdoc">Send custom notification to player from server.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00089">NotificationSystem.c:89</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a47e99473c0951cd0293de412b3d51d53"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a47e99473c0951cd0293de412b3d51d53">NotificationSystem::m_TimeArray</a></div><div class="ttdeci">protected ref array&lt; ref NotificationRuntimeData &gt; m_TimeArray</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00063">NotificationSystem.c:63</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a8801348912f09d638199bf0596cbe7d8"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a8801348912f09d638199bf0596cbe7d8">NotificationSystem::AddNotificationExtended</a></div><div class="ttdeci">static void AddNotificationExtended(float show_time, string title_text, string detail_text=&quot;&quot;, string icon=&quot;&quot;)</div><div class="ttdoc">Send custom notification from to local player.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00180">NotificationSystem.c:180</a></div></div>
<div class="ttc" id="aclass_notification_system_html_a965295e193b080aec761f91b9dcee6fb"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#a965295e193b080aec761f91b9dcee6fb">NotificationSystem::m_Instance</a></div><div class="ttdeci">static protected ref NotificationSystem m_Instance</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00061">NotificationSystem.c:61</a></div></div>
<div class="ttc" id="aclass_notification_system_html_aa3167112d04099cca93084c8331ed90a"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#aa3167112d04099cca93084c8331ed90a">NotificationSystem::GetNotificationData</a></div><div class="ttdeci">protected NotificationData GetNotificationData(NotificationType type)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00231">NotificationSystem.c:231</a></div></div>
<div class="ttc" id="aclass_notification_system_html_ab5a00ea7e797bc6798e507516af874d6"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#ab5a00ea7e797bc6798e507516af874d6">NotificationSystem::JSON_FILE_PATH</a></div><div class="ttdeci">static protected const string JSON_FILE_PATH</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00058">NotificationSystem.c:58</a></div></div>
<div class="ttc" id="aclass_notification_system_html_abb2abcf6b225ed82998c244a18207300"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#abb2abcf6b225ed82998c244a18207300">NotificationSystem::BindOnRemove</a></div><div class="ttdeci">static void BindOnRemove(func fn)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00283">NotificationSystem.c:283</a></div></div>
<div class="ttc" id="aclass_notification_system_html_ac091ea48d83274601ebb9c2b588fc3d6"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#ac091ea48d83274601ebb9c2b588fc3d6">NotificationSystem::m_DataArray</a></div><div class="ttdeci">protected ref map&lt; NotificationType, ref NotificationData &gt; m_DataArray</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00065">NotificationSystem.c:65</a></div></div>
<div class="ttc" id="aclass_notification_system_html_ac129cd2c54317d2f5263c3d5c519e17c"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#ac129cd2c54317d2f5263c3d5c519e17c">NotificationSystem::MAX_NOTIFICATIONS</a></div><div class="ttdeci">static protected const int MAX_NOTIFICATIONS</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00059">NotificationSystem.c:59</a></div></div>
<div class="ttc" id="aclass_notification_system_html_ac63f365098df3610099b710a80b939f9"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#ac63f365098df3610099b710a80b939f9">NotificationSystem::SendNotificationToPlayerIdentity</a></div><div class="ttdeci">static void SendNotificationToPlayerIdentity(PlayerIdentity player, NotificationType type, float show_time, string detail_text=&quot;&quot;)</div><div class="ttdoc">Send notification from default types to player identity from server.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00139">NotificationSystem.c:139</a></div></div>
<div class="ttc" id="aclass_notification_system_html_acb32923e01fc67d980439e7da2407c6a"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#acb32923e01fc67d980439e7da2407c6a">NotificationSystem::m_OnNotificationRemoved</a></div><div class="ttdeci">protected ref ScriptInvoker m_OnNotificationRemoved</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00068">NotificationSystem.c:68</a></div></div>
<div class="ttc" id="aclass_notification_system_html_adf618ab8cfabc3d79cbc3f35c26621fa"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#adf618ab8cfabc3d79cbc3f35c26621fa">NotificationSystem::NotificationSystem</a></div><div class="ttdeci">void NotificationSystem()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00070">NotificationSystem.c:70</a></div></div>
<div class="ttc" id="aclass_notification_system_html_ae7e705691ea84eaf201e629d1643d7c4"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#ae7e705691ea84eaf201e629d1643d7c4">NotificationSystem::AddNotification</a></div><div class="ttdeci">static void AddNotification(NotificationType type, float show_time, string detail_text=&quot;&quot;)</div><div class="ttdoc">Send notification from default types to local player.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00156">NotificationSystem.c:156</a></div></div>
<div class="ttc" id="aclass_notification_system_html_aebd399f19f7b9dbc9af2bdb868240121"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#aebd399f19f7b9dbc9af2bdb868240121">NotificationSystem::UnbindOnAdd</a></div><div class="ttdeci">static void UnbindOnAdd(func fn)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00278">NotificationSystem.c:278</a></div></div>
<div class="ttc" id="aclass_notification_system_html_af38241f43138ced69a912cbc0cf36b28"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#af38241f43138ced69a912cbc0cf36b28">NotificationSystem::SendNotificationToPlayerIdentityExtended</a></div><div class="ttdeci">static void SendNotificationToPlayerIdentityExtended(PlayerIdentity player, float show_time, string title_text, string detail_text=&quot;&quot;, string icon=&quot;&quot;)</div><div class="ttdoc">Send custom notification to player identity from server.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00105">NotificationSystem.c:105</a></div></div>
<div class="ttc" id="aclass_notification_system_html_af5398c705e25a566eed46024a86fdb71"><div class="ttname"><a href="../../d8/d5d/class_notification_system.html#af5398c705e25a566eed46024a86fdb71">NotificationSystem::Update</a></div><div class="ttdeci">static void Update(float timeslice)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d74/_notification_system_8c_source.html#l00200">NotificationSystem.c:200</a></div></div>
<div class="ttc" id="aclass_player_identity_html"><div class="ttname"><a href="../../df/d11/class_player_identity.html">PlayerIdentity</a></div><div class="ttdoc">Player description.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d18/gameplay_8c_source.html#l00325">gameplay.c:326</a></div></div>
<div class="ttc" id="aclass_script_invoker_html"><div class="ttname"><a href="../../d4/d2d/class_script_invoker.html">ScriptInvoker</a></div><div class="ttdoc">ScriptInvoker Class provide list of callbacks   usage:</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/ded/2___game_lib_2tools_8c_source.html#l00115">tools.c:116</a></div></div>
<div class="ttc" id="aclass_script_invoker_html_a704b1e426e4369c79a8495f63cfe5eed"><div class="ttname"><a href="../../d4/d2d/class_script_invoker.html#a704b1e426e4369c79a8495f63cfe5eed">ScriptInvoker::Remove</a></div><div class="ttdeci">proto void Remove(func fn)</div><div class="ttdoc">remove specific call from list</div></div>
<div class="ttc" id="aclass_script_invoker_html_a92afb05a0027c1949c5364a8e035e1c9"><div class="ttname"><a href="../../d4/d2d/class_script_invoker.html#a92afb05a0027c1949c5364a8e035e1c9">ScriptInvoker::Invoke</a></div><div class="ttdeci">proto void Invoke(void param1=NULL, void param2=NULL, void param3=NULL, void param4=NULL, void param5=NULL, void param6=NULL, void param7=NULL, void param8=NULL, void param9=NULL)</div><div class="ttdoc">invoke call on all inserted methods with given arguments</div></div>
<div class="ttc" id="aclass_script_invoker_html_abeb2392b2e3dc0a34d0c5cafc96a288e"><div class="ttname"><a href="../../d4/d2d/class_script_invoker.html#abeb2392b2e3dc0a34d0c5cafc96a288e">ScriptInvoker::Insert</a></div><div class="ttdeci">proto void Insert(func fn)</div><div class="ttdoc">insert method to list</div></div>
<div class="ttc" id="aclass_script_r_p_c_html"><div class="ttname"><a href="../../d5/d8a/class_script_r_p_c.html">ScriptRPC</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d18/gameplay_8c_source.html#l00104">gameplay.c:105</a></div></div>
<div class="ttc" id="aclass_script_r_p_c_html_a96f5185fa93cf7f008fba76a0e7729b9"><div class="ttname"><a href="../../d5/d8a/class_script_r_p_c.html#a96f5185fa93cf7f008fba76a0e7729b9">ScriptRPC::Send</a></div><div class="ttdeci">proto native void Send(Object target, int rpc_type, bool guaranteed, PlayerIdentity recipient=NULL)</div><div class="ttdoc">Initiate remote procedure call. When called on client, RPC is evaluated on server; When called on ser...</div></div>
<div class="ttc" id="aclass_serializer_html_a3568bd9439217225013ea9906eb09a3f"><div class="ttname"><a href="../../d0/dc2/class_serializer.html#a3568bd9439217225013ea9906eb09a3f">Serializer::Write</a></div><div class="ttdeci">proto bool Write(void value_out)</div></div>
<div class="ttc" id="aclassarray_html"><div class="ttname"><a href="../../d2/d41/classarray.html">array</a></div><div class="ttdoc">Result for an object found in CGame.IsBoxCollidingGeometryProxy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcd/_is_box_colliding_geometry_proxy_classes_8c_source.html#l00027">IsBoxCollidingGeometryProxyClasses.c:28</a></div></div>
<div class="ttc" id="agameplay_8c_html_aebb1fa6632d513bc849994e7b6c9c93d"><div class="ttname"><a href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a></div><div class="ttdeci">proto native CGame GetGame()</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_5eccb71dd63ea3c42a1369b85c71c9fd.html">3_Game</a></li><li class="navelem"><a class="el" href="../../dir_ffaed77935c4a5e2d01fbe96792eb0d5.html">Client</a></li><li class="navelem"><a class="el" href="../../dir_b249e7cedc01ba5b1de7b8a90beb0b2a.html">Notifications</a></li><li class="navelem"><a class="el" href="../../d5/d74/_notification_system_8c.html">NotificationSystem.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
